// IoObjectIf.h: o̓IuWFNgC^tF[X
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// Wt@CXg[WC^tF[X
/////////////////////////////////////////////////////////////////////////////

class ISmartFile :				public IBonObject
{
public:
	enum
	{
		MF_READ			= 0x00000001UL,		// ǂݏo[h
		MF_WRITE		= 0x00000002UL		// ݃[h
	};

	virtual const bool Open(LPCTSTR lpszFileName, const DWORD dwModeFlags = MF_READ, const DWORD dwBuffSize = 0UL) = 0;
	virtual void Close(void) = 0;

	virtual const DWORD ReadData(BYTE *pBuff, const DWORD dwLen) = 0;
	virtual const DWORD ReadData(BYTE *pBuff, const DWORD dwLen, const ULONGLONG llPos) = 0;

	virtual const DWORD WriteData(const BYTE *pBuff, const DWORD dwLen) = 0;
	virtual const DWORD WriteData(const BYTE *pBuff, const DWORD dwLen, const ULONGLONG llPos) = 0;

	virtual const bool FlushData(void) = 0;

	virtual const bool SeekPos(const ULONGLONG llPos) = 0;
	virtual const ULONGLONG GetPos(void) = 0;

	virtual const ULONGLONG GetLength(void) = 0;
};
